#!/bin/bash

set -euxo pipefail

TARGET_H_TEMPLATE=../../../include/target.h.in
TARGET_H_FILE=../../../include/target.h

WOLFBOOT_SECTOR_SIZE=0x4000
# Partition size determinded by the following:
# 3M PFLASH bank, minus one sector (swap), divided in half
WOLFBOOT_PARTITION_SIZE=0x17E000
WOLFBOOT_PARTITION_BOOT_ADDRESS=0xA0300000
WOLFBOOT_PARTITION_UPDATE_ADDRESS=0xA047E000
# Last sector in PFLASH1 allocated to swap
WOLFBOOT_PARTITION_SWAP_ADDRESS=0xA05FC000

WOLFBOOT_DTS_BOOT_ADDRESS=
WOLFBOOT_DTS_UPDATE_ADDRESS=
WOLFBOOT_LOAD_ADDRESS=
WOLFBOOT_LOAD_DTS_ADDRESS=

cat $TARGET_H_TEMPLATE | \
	sed -e "s/@WOLFBOOT_PARTITION_SIZE@/$WOLFBOOT_PARTITION_SIZE/g" | \
	sed -e "s/@WOLFBOOT_SECTOR_SIZE@/$WOLFBOOT_SECTOR_SIZE/g" | \
	sed -e "s/@WOLFBOOT_PARTITION_BOOT_ADDRESS@/$WOLFBOOT_PARTITION_BOOT_ADDRESS/g" | \
	sed -e "s/@WOLFBOOT_PARTITION_UPDATE_ADDRESS@/$WOLFBOOT_PARTITION_UPDATE_ADDRESS/g" | \
	sed -e "s/@WOLFBOOT_PARTITION_SWAP_ADDRESS@/$WOLFBOOT_PARTITION_SWAP_ADDRESS/g" | \
	sed -e "s/@WOLFBOOT_DTS_BOOT_ADDRESS@/$WOLFBOOT_DTS_BOOT_ADDRESS/g" | \
	sed -e "s/@WOLFBOOT_DTS_UPDATE_ADDRESS@/$WOLFBOOT_DTS_UPDATE_ADDRESS/g" | \
	sed -e "s/@WOLFBOOT_LOAD_ADDRESS@/$WOLFBOOT_LOAD_ADDRESS/g" | \
	sed -e "s/@WOLFBOOT_LOAD_DTS_ADDRESS@/$WOLFBOOT_LOAD_DTS_ADDRESS/g" \
		> $TARGET_H_FILE

